#!/bin/sh

#----- Print Usage !! -----#
if test "$#" -ne 1
then echo " "
     echo " Print_Usage !!"  
     echo " "  
     echo " check_hkdat.sh  camid"
     echo " check_hkdat.sh  C01   "
     echo " "  
     exit 0
fi

export LC_ALL=C

# Camera ID
CID=$1

# Home path
HOMDIR=/home/lcas
DBXDIR=${HOMDIR}/Dropbox/${CID}
HKFILE=${HOMDIR}/${CID}_hkdata.txt

echo "" > ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Date of Latest Update:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
/bin/date >> ${HKFILE}

echo "" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Disk Usage:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
df -h    >> ${HKFILE}

echo "" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Memory Usage:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
free >> ${HKFILE}

echo "" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Current crontab Entries:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
crontab -l >> ${HKFILE}

echo "" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Video Device Status:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
v4l2-ctl --list-devices >> ${HKFILE}

echo "------------------------------------------------------------" >> ${HKFILE}
echo "NTP Time Adjustment Status:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
ntpq -p >> ${HKFILE}

echo "" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
echo "Dropbox File Synchronization Status:" >> ${HKFILE}
echo "------------------------------------------------------------" >> ${HKFILE}
dropbox status >> ${HKFILE}

mv ${HKFILE} ${DBXDIR}/
